<template lang="pug">
  .auth(:class="{ mobile: isMobile }")
    .loader(v-if="loading")
    template(v-else)
      .logged-in(
        v-if="user && user.roles.find(role => role === 'user')"
        v-on:click="showMenu = !showMenu"
        ref="menuButton"
      )
        .icon(v-html="$icons.rasterUser" v-if="!user.license")
        .icon(v-html="$icons.allAccess" v-else)
        .email(v-if="isMobile") {{ user.email }}
        .menu-icon(v-html="$icons.menuArrowDown")
      div(
        v-else
        @click="$modal.show('login-modal')"
        class="login-button"
        v-bind:class="{ 'login-button--black': isLanding }"
      )
        .icon(v-html="$icons.icons8")
        div Login with Icons8
    transition(name="scale-fade")
      .sub-menu(
        v-show="showMenu && user"
        ref="menu"
      )
        .sub-menu-row(
          v-if="userCollages.total"
          v-on:click="showUserCollages()"
        )
          .link
            .text My photos
            .spacer
            .badge {{ userCollages.total }}
        .sub-menu-row
          a.link(href="https://icons8.com/profile/summary" target="_blank") Settings
        .sub-menu-row(v-on:click="logout")
          .link Logout
    app-modal(
      ref="modal"
      name="login-modal"
      v-bind:width="520"
      v-bind:contentClass="'login-modal'"
    )
      login-form(v-on:success="success")
</template>

<script>
import { mapState } from 'vuex'
import dataService from '../services/data'

export default {
  name: 'Auth',
  props: {
    isLanding: {
      default: false,
      type: Boolean
    },
    isMobile: {
      default: false,
      type: Boolean
    }
  },
  data () {
    return {
      loading: true,
      showMenu: false,
      icons8UserLoaded: false
    }
  },
  computed: {
    ...mapState({
      user: state => state.editor.user,
      userCollages: state => state.editor.userCollages
    })
  },
  created () {
    if (this.isMobile && this.user) {
      this.loading = false
    }
    if (this.user) {
      this.getCollages()
    } else {
      this.getUser()
    }
  },
  mounted () {
    document.addEventListener('mousedown', this.outsideClick)
  },
  destroyed () {
    document.removeEventListener('mousedown', this.outsideClick)
  },
  methods: {
    getUser () {
      dataService.getUser().then(() => this.getCollages())
    },
    getCollages () {
      dataService.getCollages({ per_page: 100 })
        .then(() => {
          this.loading = false
          this.$emit('ready')
        })
    },
    showUserCollages () {
      this.showMenu = false
      this.$router.push({ name: 'creator-dashboard', params: { tabName: 'USER_COLLAGES' } })
    },
    logout () {
      this.loading = true
      this.showMenu = false
      this.$store.dispatch('logoutUser').then(() => this.getUser())
    },
    success () {
      this.getUser()
    },
    outsideClick (event) {
      if (
        this.$refs.menu &&
        this.$refs.menuButton &&
        !this.$refs.menu.contains(event.target) &&
        !this.$refs.menuButton.contains(event.target)
      ) {
        this.showMenu = false
      }
    }
  }
}
</script>

<style lang="scss" scoped>
@import "../assets/css/mixins";
@import "../assets/css/effects";

.auth {
  position: relative;
  height: 32px;
  min-width: 47px;
  color: #fff;

  .loader {
    width: 32px;
    height: 32px;
    position: relative;
    @include loading(#fff, 3px, 24px);
  }

  .logged-in {
    display: flex;
    flex-direction: row;
    align-items: center;
    cursor: pointer;

    .menu-icon {
      width: 10px;
      height: 10px;
      margin-left: 5px;
      fill: #8c8c8c;
    }

    .email {
      margin: 0 3px 0 8px;
    }

    .icon {
      min-width: 32px;
      min-height: 32px;
      width: 32px;
      height: 32px;
      border-radius: 27px;
      overflow: hidden;
    }
  }

  .login-button {
    width: 176px;
    height: 32px;
    display: flex;
    flex-direction: row;
    align-items: center;
    border-radius: 10px;
    cursor: pointer;
    align-items: center;
    justify-content: center;
    background-color: #4ac144;
    font-size: 14px;
    color: #fff;

    &--black {
      background-color: #1a1a1a;
      width: 100%;
      height: 52px;
      padding: 0 24px;
      border-radius: 52px;
    }

    .icon {
      width: 28px;
      height: 18px;
      padding-right: 10px;
      fill: #fff;
    }
  }

  &.mobile {
    /deep/ .sub-menu {
      left: 0;
      right: initial;
      box-shadow: 0 0 5px #000;
    }
  }
}
</style>
